PROGRAM conred52;
{$F+}
{***********************************************************
"Dibujo del Lugar geomtrico de S(1) en un control secuencial"
Autores: JRomero - Arodri
Fecha: 18-04-98

		 La simulacin corresponde a un convertidor en el
		 que se implementa un control secuencial,
		 y se observarn los siguientes parmetros:

		 * tensiones de salida de cada puente de tiristores
		 y la suma de ambas.
		 * curva Power Locus del primer armnico
		 * valores de Potencia aparente, activa y reactiva del
		 1er. armnico.

		 OBS. para preservar la coherencia de la grfica, se
		 cosiderar el valor de alpha min y max en 10 y 170.

**********************************************************}

USES
wincrt, xmatdefs, wingraph, FilUSR, UCntrl, Simul4, traxp, variable,
lib_basi, libep02, libep, libdig01;

CONST w=PI*100;           {frecuencia de red=50 hz}
		periodo=20e-3;      {periodo=2*PI/w}
		Npuntos=1024;       {nmero de puntos de muestreo}
		alphamin=10; 			{valores de alpha minimo y maximo}
		alphamax=170;
		ID=1;						{corriente de salida}
		U=380;					{tensin  pico de linea}
		sexrad=PI/180;

var
	control,udt,ud1,ud2,s1,q1,p1,alpha1,a_viejo1,alpha2,a_viejo2:NReal;  {variables para visualizar en pantalla}

	LOOP_NUEVO_VALOR:BOOLEAN;
	control_boton:NReal;


(*************************************************************************)
(*************************************************************************)
(*************************************************************************)
(*
	Procedimientos para dibujar el Power Locus del 1er. armnico.

	poner_Flecha imprime un vector con un label.

	PowerLocus   imprime el grfico completo.
*)

PROCEDURE poner_FLECHA(X2,Y2,x1,y1:integer;texto:string;color:Byte);
const  	M=4;
			N=0.95;
var 		x3,x4,y3,y4:integer;
			L:NReal;
BEGIN

	SetColor(color);    {borro anterior vector}
	SetLineStyle(0,0,0);

	L:=SQRT(SQR(x2-x1)+SQR(y2-y1));

	{poner la flecha}
	x3:=Round( M/L*(y2-y1) + N*(x2-x1) + x1 );
	y3:=Round( M/L*(x1-x2) + N*(y2-y1) + y1 );
	x4:=Round( -M/L*(y2-y1) + N*(x2-x1) + x1 );
	y4:=Round( -M/L*(x1-x2) + N*(y2-y1) + y1 );
	Line(x2,y2,x3,y3);
	Line(x2,y2,x4,y4);

	{poner el segmento}
	Line(x2 , y2, x1, y1);

	{calcular el centro del segmento}
	x3:=Round( 0.5*(x2-x1) + x1 );
	y3:=Round( 0.5*(y2-y1) + y1 );

	{poner texto en el centro}
	OutTextXY(x3+1,y3+1,texto);
end;

PROCEDURE POWER_LOCUS(A1,A2:NReal);
const radio=100;
		radio2=50;
		{origen del grfico}
		origenX=150;
		origenY=452;
		X210=49;
		Y210=9;

var  	x2,y2,x3,y3:integer;
BEGIN
	if (A_viejo1<>A1) or (A_viejo2<>A2) then
	begin
		X2:=Round(RADIO/2* COS(A_viejo1*PI/180));
		Y2:=Round(RADIO/2* SIN(A_viejo1*PI/180));

		X3:=Round(RADIO/2* COS(A_viejo2*PI/180));
		Y3:=Round(RADIO/2* SIN(A_viejo2*PI/180));

		{borrar anterior}
		poner_flecha(x2+origenX,-y2+origenY,origenX,origenY,'S1(1)',3);
		poner_flecha(x2+origenX+x3,-y3-y2+origenY,x2+origenX,-y2+origenY,'S2(1)',3);
		setcolor(3);{ejes secundarios}
		SetLineStyle(0,0,0);
		ARC(x2+origenX, -y2+origenY,0,180, radio2);
		Line(x2+origenX-radio2-10,-y2+origenY,x2+origenX+radio2+10,-y2+origenY);
		Line(x2+origenX,-y2+origenY+10,x2+origenX,-y2+origenY-(radio2+10));
		SetLineStyle(1,0,0);
		Line(origenx,-y3-y2+origenY,x2+origenX+x3,-y3-y2+origenY);
		Line(x2+origenX+x3,-y3-y2+origenY,x2+origenX+x3,origenY);


		{poner actual}
		SetLineStyle(0,0,3);
		SetColor(1);
		Line(origenX-radio-10,origenY, origenX+radio+10, origenY);
		Line(origenX,origenY, origenX, origenY-radio-10);
		ARC(origenX, origenY, 0,180, radio);
		{arcos del recorriod completo}
		SetLineStyle(0,0,0);
		ARC(X210+origenX, -Y210+origenY,alphamin,alphamax, radio2);
		ARC(-X210+origenX, -Y210+origenY,alphamin,alphamax, radio2);

		X2:=Round(RADIO/2* COS(A1*PI/180));
		Y2:=Round(RADIO/2* SIN(A1*PI/180));

		X3:=Round(RADIO/2* COS(A2*PI/180));
		Y3:=Round(RADIO/2* SIN(A2*PI/180));


		{barras en los ejes}
		setlinestyle(0,0,0);
		setcolor(12);
		Line(origenx,origeny,x2+origenX+x3,origeny);
		Line(origenx,origeny,origenx,-y3-y2+origenY);


		poner_flecha(x2+origenX,-y2+origenY,origenX,origenY,'S1(1)',14);
		poner_flecha(x2+origenX+x3,-y3-y2+origenY,x2+origenX,-y2+origenY,'S2(1)',15);
		SetLineStyle(0,0,0);
		setcolor(0);	{ejes secundarios}
		ARC(x2+origenX, -y2+origenY,0,180, radio2);
		Line(x2+origenX-radio2-10,-y2+origenY,x2+origenX+radio2+10,-y2+origenY);
		Line(x2+origenX,-y2+origenY+10,x2+origenX,-y2+origenY-(radio2+10));

		SetColor(1);
		SetLineStyle(1,0,0);
		Line(origenx,-y3-y2+origenY,x2+origenX+x3,-y3-y2+origenY);
		Line(x2+origenX+x3,-y3-y2+origenY,x2+origenX+x3,origenY);


		SetLineStyle(0,0,0);

		OutTextXY(origenX+radio+12,origenY-4,'P');
		OutTextXY(origenX+3,origenY-radio-12,'Q');


		OutTextXY(origenX+radio+40,origenY-100,'   Los convertidores tienen');
		OutTextXY(origenX+radio+40,origenY-90,'potencias aparentes S1 y S2');
		OutTextXY(origenX+radio+40,origenY-80,'determinadas por:');
		OutTextXY(origenX+radio+40,origenY-65,'   S1(1) = P1(1) + j Q1(1)');
		OutTextXY(origenX+radio+40,origenY-55,'   S2(1) = P2(1) + j Q2(1)');
		OutTextXY(origenX+radio+40,origenY-40,'donde P1(1)=1.35 U Id cos('+chr(224)+'1)');
		OutTextXY(origenX+radio+40,origenY-30,'      Q1(1)=1.35 U Id sen('+chr(224)+'1)');
		OutTextXY(origenX+radio+40,origenY-20,'      P2(1)=1.35 U Id cos('+chr(224)+'2)');
		OutTextXY(origenX+radio+40,origenY-10,'      Q2(1)=1.35 U Id sen('+chr(224)+'2)');
	end;
	A_viejo1:=A1;
	A_viejo2:=A2;
END;
(*************************************************************************)
(*************************************************************************)
(*************************************************************************)


{*********************************************************
A continuacin los procedimientos Cirt1, Cirt2 y Funcsr de
definicin del circuito.
*********************************************************}
{----------------------------------------------------------------------}

PROCEDURE CIRT1;
BEGIN
vg(1,0,1,1);		{ud1}
vg(2,1,2,1);		{ud2}
vg(3,0,3,1);
vg(4,3,4,1);
r(0,4,1);
r(0,2,1);
END;

{----------------------------------------------------------------------}

PROCEDURE CIRT2;
BEGIN
END;

{----------------------------------------------------------------------}

PROCEDURE FUNCSR(t:NReal);
var anguloPI3:NReal;

{funcion para el calculo de UDx por segmentos de PI/3}
function regionPI3(angulo,alpha:NReal):NReal;
begin
if alpha<PI/6 then
begin
	if (alpha+PI/6)>angulo then
		regionPI3:=cos(angulo)
	else
		regionPI3:=cos(angulo-PI/3);
end
else
	if alpha<PI/2 then
	begin
		if (alpha-PI/6)>angulo then
			regionPI3:=cos(angulo+PI/3)
		else
			regionPI3:=cos(angulo);
	end
	else
		if alpha<5*PI/6 then
		begin
			if (alpha-PI/2)>angulo then
					regionPI3:=cos(angulo+2*PI/3)
			else
					regionPI3:=cos(angulo+PI/3);
		end
		else
			if alpha<7*PI/6 then
			begin
				if (alpha-5*PI/6)>angulo then
						regionPI3:=cos(angulo+3*PI/3)
				else
						regionPI3:=cos(angulo+2*PI/3);
			end;
end;

function iR(wt,alpha:NReal):NReal;
begin
	wt:=wt-PI/12;{ajuste}
	{problema de doblamiento}

	wt:=wt-alpha;
	if wt<0 then wt:=2*PI+wt;

	{esto de abajo es para alpha=0}
	if wt< (PI/12) then ir:=0 else
	if wt< (PI/12+2*PI/3) then ir:=Id else
	if wt< (PI+PI/12) then ir:=0 else
	if wt< (PI+PI/12+2*PI/3) then ir:=-Id else
	ir:=0;
end;

BEGIN
	anguloPI3:=w*t;
	rf[3]:=ir(anguloPI3,alpha1*sexrad);
	rf[4]:=ir(anguloPI3,alpha2*sexrad);

	while	anguloPI3>PI/3 do anguloPI3:=anguloPI3-PI/3;
	rf[1]:=3/PI*1.4142*(U/2)*regionPI3(anguloPI3,alpha1*sexrad);
	rf[2]:=3/PI*1.4142*(U/2)*regionPI3(anguloPI3,alpha2*sexrad);
END;

{----------------------------------------------------------------------}

{********************************************************
A continuacin los procedimientos de inicio, fin  y Pesca
necesarios para Simeep
*********************************************************}

PROCEDURE INICIO;
BEGIN
nn:=4;			{nmero de nodos del circuito sin incluir 0 (Tierra)}
nindep:=4;		{nmero de fuentes independientes}
tinicial:=0e-3;   {tiempo incial de cada simulacin}
tfinal:=20e-3; {tiempo final de cada simulacin}

{valores de precisin de Simeep}
dtmax0:=10e-6;
dtmin:=dtmax0/100;
PasoDivisor:=6;
TmaxTmin:=1e3;

{inicializacin de la unidad de grficos}
traxp.tinicial:=tinicial;
traxp.tfinal:=tfinal;

subplot(1,3);

gridx:=12;
gridy:=12;

{primera pantalla}
definaY(0,-600,100);
titulo('ud1(rojo), ud2(azul)  y ud = ud1+ud2 (amarillo)');
xlabel('30/DIV');
ylabel('100 V/DIV');
linea0;
grid;

{segunda pantalla}
definaY(1,0,1);
titulo('La iR que ve la red es iR1+iR2.');
xlabel('30/DIV');
ylabel('  iR2  iR1    iRt');
grid;

{tercera pantalla, reservada para poner nuestro grfico}
definaY(2,-400,200);
titulo('Grfico del lugar geomtrico de S(1)');

Superponga(3,0);
Superponga(4,0);

Superponga(5,1);
Superponga(6,1);

definacolor(0,rojo);
definacolor(3,azul);
definacolor(4,amarillo);

definacolor(1,rojo);
definacolor(5,azul);
definacolor(6,amarillo);
END;

PROCEDURE PESCA;
var   k:Integer;

BEGIN

if not LOOP_NUEVO_VALOR then
begin

	{aqui se modifican los valores de alpha1 y alpha2}
	if control < 180 then
	begin
		alpha1:=10;
		alpha2:=control-10;
	end
	else
	begin
		alpha1:=control-170;
		alpha2:=170;
	end;

	ud1:=3*1.4142*(U/2)*cos(alpha1*sexrad)/PI;
	ud2:=3*1.4142*(U/2)*cos(alpha2*sexrad)/PI;

	p1:=Id*(ud1+ud2);
	q1:=1.350474474*(U/2)*ID*(sin(alpha1*sexrad)+sin(alpha2*sexrad));

	s1:=SQRT(SQR(p1)+SQR(q1));

	udt:=ud1+ud2;

	traxp.t:=t;
	trazo(0,v[1]);
	trazo(3,v[2]-v[1]);
	trazo(4,v[2]);

	trazo(1,v[3]+2);
	trazo(1,2);
	trazo(5,v[4]-v[3]+5);
	trazo(5,5);
	trazo(6,v[4]+9);
	trazo(6,9);

	{nueva "simulacin"}
	if t >= tfinal then
	begin

	{pintar grfica}
	POWER_LOCUS(Alpha1,alpha2);

	if control=control_boton then
	begin
		LOOP_NUEVO_VALOR:=true;
		while control=control_boton do
		begin
			FilUsr.Pesca;
		end;
		LOOP_NUEVO_VALOR:=false;
	end;
	control:=control_boton;


	{reponer pantalla}
	for k:=0 to 6 do
	begin
		if k<> 2 then
		begin
			borrecanal(k,0);
			desligue(k);
			borde;
			grid;
			linea0;
		end;
	end;

		t:= t-tfinal+tinicial;
	end;

end;
END;

{----------------------------------------------------------------------}

PROCEDURE FIN;
BEGIN
TermineGr;		{terminar los grficos}
HALT;
END;

{----------------------------------------------------------------------}

PROCEDURE INICIALIZACION_DE_PARAMETROS;
BEGIN
ticsvisualizacion:=10;{frecuencia con la que se va a mostrar las variables}
quita:=6;
a_viejo1:=11;
a_viejo2:=11;
alpha1:=10;
alpha2:=10;
LOOP_NUEVO_VALOR:=false;
control:=20;
END;


{******************************PRINCIPAL*******************************}
BEGIN
INICIALIZACION_DE_PARAMETROS;
{Indicamos a Simeep donde estn las funciones que preparamos}
FilUSR.Cirt1:=Cirt1;
FilUSR.Cirt2:=Cirt2;
FilUSR.FuncsR:=FuncsR;
FilUSR.Inicio:=Inicio;
FilUSR.Pesca:=Pesca;
FilUsr.Fin:=Fin;
{Pantalla de controles}
UCntrl.init;

{------------------PARA VISUALIZAR TEXTO EN LA SIMULACION--------------}

UCntrl.insert(new(PCtrlVerTexto,init
(    0,   '  Control Secuencial','---------------------',   ' ')));


{---------------PARA CONTROLAR VARIABLES EN LA SIMULACION--------------}


{-----------------PARA VER VARIABLES EN LA SIMULACION------------------}


UCntrl.insertdisplay(new(PCtrlVer2Var,init
{ renglon, nombre1, uni1, deci1,  var1 , nombre2, uni2, deci2, var2}
(    4,   'P(1)',  'p.u.',     2  , p1 ,     'Q(1)', 'p.u.',     0, q1)));

UCntrl.insertdisplay(new(PCtrlVer2Var,init
{ renglon, nombre1, uni1, deci1,  var1 , nombre2, uni2, deci2, var2}
(    5,   ' S(1) ',  'p.u.',   2  , s1 ,     'Ud total', 'V',    2, udt)));

UCntrl.insertdisplay(new(PCtrlVer2Var,init
{ renglon, nombre1, uni1, deci1,  var1 , nombre2, uni2, deci2, var2}
(    6,   '	Ud1',  'V',     2  , ud1 ,     'Ud2', 'V',    2, ud2)));

UCntrl.insertdisplay(new(PCtrlVer2Var,init
{ renglon, nombre1, uni1, deci1,  var1 , nombre2, uni2, deci2, var2}
(    7, chr(224)+'1',  '',     0  , alpha1 , chr(224)+'2', '',   0, alpha2)));


UCntrl.insert(new(PCtrlBotonVar,init
(   8 ,  ' '+ chr(224)+'1 + '+chr(224)+'2',   '',   0  ,  2*alphamin, 2*alphamax, 20,    10, control_boton)));

{----------------------------------------------------------------------}
{Inicio de Simulaciones}
PASEO;
END.
